import es
import gamethread
import playerlib

class SpawnProtection(object):
	def __init__(self):
		self.protTime = es.ServerVar('dd_sp_time')
		self.useNoBlock = es.ServerVar('dd_sp_noblock')
		self.changeColor = es.ServerVar('dd_sp_color_enabled')
		self.delays = []

	def protectOn(self,userid):
		if 'protectionDelay_%s' % userid in self.delays:
			gamethread.cancelDelayed('protectionDelay_%s' % userid)
			self.delays.remove('protectionDelay_%s' % userid)
		player = playerlib.getPlayer(userid)
		player.godmode = 1
		if self.changeColor: player.setColor(255,0,0,200)
		if self.useNoBlock: es.setplayerprop(userid,'CBaseEntity.m_CollisionGroup',2)
		self.delays.append('protectionDelay_%s' % userid)
		gamethread.delayedname(self.protTime,'protectionDelay_%s' % userid,self.protectOff,userid)

	def protectOff(self,userid,delete=True):
		gamethread.cancelDelayed('protectionDelay_%s' % userid)
		if 'protectionDelay_%s' % userid in self.delays and delete: self.delays.remove('protectionDelay_%s' % userid)
		if es.getuserid(userid):
			if es.getplayerteam(userid) > 1:
				player = playerlib.getPlayer(userid)
				if not player.get('isdead'):
					player.godmode = 0
					if self.changeColor: player.setColor(255,255,255,255)
					if self.useNoBlock: es.setplayerprop(userid,'CBaseEntity.m_CollisionGroup',0)

	def clear(self):
		for delay in self.delays:
			self.protectOff(delay.replace('protectionDelay_',''),False)
			gamethread.cancelDelayed(delay)
		del self.delays[:]

protect = SpawnProtection()

def unload():
	protect.clear()

def es_map_start(ev):
	protect.clear()

def player_spawn(ev):
	userid = int(ev['userid'])
	if es.getplayerteam(userid) > 1: protect.protectOn(userid)

def player_death(ev):
	protect.protectOff(int(ev['userid']))